const xlsx = require("node-xlsx").default
const fs = require("fs")
const path = require("path")
const encrypt = require("crypto")

function run() {
  let encryptFile = []
  let dictFile = []
  let count = 0

  console.log("开始解析excel------------------")

  const list = xlsx.parse(`${__dirname}/file.xlsx`)
  for (const item of list) {
    for (const file of item.data) {
      const target = file[1].toString()
      const addStr = encrypt.createHash("md5").update(target).digest("hex").toString()
      dictFile.push([...file, addStr])
      encryptFile.push([addStr])
      count++
    }
  }

  console.log(`共解析${count}条数据---------------`)

  const encryptFileBuffer = xlsx.build([
    {name: 'Sheet1', data: encryptFile},
  ])
  const dictFileBuffer = xlsx.build([
    {name: 'Sheet1', data: dictFile},
  ])

  fs.writeFile(path.resolve(process.cwd(), "encrypt.xlsx"), encryptFileBuffer, (err) => {
    if (err)
      console.log(err);
    else {
      console.log("加密完成--------------------")
    }
  })

  fs.writeFile(path.resolve(process.cwd(), "dict.xlsx"), dictFileBuffer, (err) => {
    if (err)
      console.log(err);
    else {
      console.log("映射完成--------------------")
    }
  })
}

module.exports = {
  run
}

